﻿(function () {

    "use strict";

    // "Private" members
    var countdownSecondsRemaining;
    var countdownIntervalPromise;
    var countdownCompleteCallback;

    angular.module("enrServicesModule")
           .factory("secondsCountdown", ["$interval", function ($interval) {
               return {

                   start: function (secondsRemaining, timesUpCallback) {
                       countdownSecondsRemaining = secondsRemaining;
                       countdownCompleteCallback = timesUpCallback;

                       // End any current countdown
                       if (countdownIntervalPromise != undefined)
                           $interval.cancel(countdownIntervalPromise);

                       // Kickoff the countdown
                       countdownIntervalPromise = $interval(function () {
                           countdownSecondsRemaining -= 1;

                           if (countdownSecondsRemaining === 0) {
                               $interval.cancel(countdownIntervalPromise);
                               countdownIntervalPromise = undefined;

                               if (countdownCompleteCallback != undefined)
                                   countdownCompleteCallback();
                           }
                       }, 1000);
                   },

                   secondsRemaining: function () { return countdownSecondsRemaining; },
                   stopInterval: function () {
                       if (angular.isDefined(countdownIntervalPromise)) {
                           $interval.cancel(countdownIntervalPromise);
                           countdownIntervalPromise = undefined;
                       }
                   }
               };
           }]);

}());